#!/usr/bin/python
# -*- coding: UTF-8 -*-

__author__ = 'Mikaël'

import plotly
from plotly.graph_objs import *

class ChartGenerator:

    def __init__(self,outputPath):
        plotly.tools.set_credentials_file(username='hellrider42', api_key='6rlehfe32h', stream_ids=['tt0qovj97n', 'pj7vmpfzml'])
        self.outputPath = outputPath
        self.noCacheExps = {}
        self.semanticCacheExps = {}
        self.decisionalSemanticCacheExps = {}

    def addNoCacheExperimentation(self,index,exp):
        if not self.noCacheExps.has_key(index):
            self.noCacheExps[index] = []

        self.noCacheExps[index].append(exp)

    def addSemanticCacheExperimentation(self,index,exp):
        if not self.semanticCacheExps.has_key(index):
            self.semanticCacheExps[index] = []

        self.semanticCacheExps[index].append(exp)

    def addDecisionalSemanticCacheExperimentation(self,index,exp):
        if not self.decisionalSemanticCacheExps.has_key(index):
            self.decisionalSemanticCacheExps[index] = []

        self.decisionalSemanticCacheExps[index].append(exp)

    def showTimes(self,graphTitle,xTitle,yTitle):

        avgNoCacheExps = [0 for i in range(0,11)]
        avgSemanticCacheExps = [0 for i in range(0,11)]
        avgDecisionalSemanticCacheExps = [0 for i in range(0,11)]

        #build average measurements\

        if self.noCacheExps.keys():
            for i in range(0,11):
                for index in self.noCacheExps.keys():
                    avgNoCacheExps[i] += self.noCacheExps[index][i].getTotalDownloadData()
                avgNoCacheExps[i] /= len(self.noCacheExps.keys())
                avgNoCacheExps[i] /= 1000000000

        if self.semanticCacheExps.keys():
            for i in range(0,11):
                for index in self.semanticCacheExps.keys():
                    avgSemanticCacheExps[i] += self.semanticCacheExps[index][i].getTotalDownloadData()
                avgSemanticCacheExps[i] /= len(self.semanticCacheExps.keys())
                avgSemanticCacheExps[i] /= 1000000000

        if self.decisionalSemanticCacheExps.keys():
            for i in range(0,11):
                for index in self.decisionalSemanticCacheExps.keys():
                    avgDecisionalSemanticCacheExps[i] += self.decisionalSemanticCacheExps[index][i].getTotalDownloadData()
                avgDecisionalSemanticCacheExps[i] /= len(self.decisionalSemanticCacheExps.keys())
                avgDecisionalSemanticCacheExps[i] /= 1000000000

        dataNoCacheExps = Scatter(
            x=[i*10 for i in range(0,11)],
            y=avgNoCacheExps,
            mode='lines+markers',
            name='No Cache'
        )

        dataSemanticCacheExps = Scatter(
            x=[i*10 for i in range(0,11)],
            y=avgSemanticCacheExps,
            mode='lines+markers',
            name='Semantic Caching'
        )

        dataDecisionalSemanticCacheExps = Scatter(
            x=[i*10 for i in range(0,11)],
            y=avgDecisionalSemanticCacheExps,
            mode='lines+markers',
            name='Decisional Semantic Caching'
        )


        #noCacheExps,dataSemanticCacheExps, dataDecisionalSemanticCacheExps,
        data = Data([dataNoCacheExps,dataSemanticCacheExps, dataDecisionalSemanticCacheExps])

        layout = Layout(
            title = graphTitle,
            xaxis = XAxis(title = xTitle),
            yaxis = YAxis(title = yTitle)
        )

        fig = Figure(data=data, layout=layout)

        plot_url = plotly.plotly.plot(fig, filename = graphTitle)
        #plotly.plotly.image.save_as(fig, self.outputPath + '/processing_time_comparison.png')


    def showEnergy(self,graphTitle,xTitle,yTitle):

        avgNoCacheExps = [0 for i in range(0,11)]
        avgSemanticCacheExps = [0 for i in range(0,11)]
        avgDecisionalSemanticCacheExps = [0 for i in range(0,11)]

        #build average measurements\

        if self.noCacheExps.keys():
            for i in range(0,11):
                for index in self.noCacheExps.keys():
                    avgNoCacheExps[i] += self.noCacheExps[index][i].getTotalEnergyConsumption()
                avgNoCacheExps[i] /= len(self.noCacheExps.keys())

        if self.semanticCacheExps.keys():
            for i in range(0,11):
                for index in self.semanticCacheExps.keys():
                    avgSemanticCacheExps[i] += self.semanticCacheExps[index][i].getTotalEnergyConsumption()
                avgSemanticCacheExps[i] /= len(self.semanticCacheExps.keys())

        if self.decisionalSemanticCacheExps.keys():
            for i in range(0,11):
                for index in self.decisionalSemanticCacheExps.keys():
                    avgDecisionalSemanticCacheExps[i] += self.decisionalSemanticCacheExps[index][i].getTotalEnergyConsumption()
                avgDecisionalSemanticCacheExps[i] /= len(self.decisionalSemanticCacheExps.keys())


        dataNoCacheExps = Scatter(
            x=[i*10 for i in range(0,11)],
            y=avgNoCacheExps,
            mode='lines+markers',
            name='No Cache'
        )

        dataSemanticCacheExps = Scatter(
            x=[i*10 for i in range(0,11)],
            y=avgSemanticCacheExps,
            mode='lines+markers',
            name='Semantic Caching'
        )

        dataDecisionalSemanticCacheExps = Scatter(
            x=[i*10 for i in range(0,11)],
            y=avgDecisionalSemanticCacheExps,
            mode='lines+markers',
            name='Decisional Semantic Caching'
        )


        #noCacheExps,dataSemanticCacheExps, dataDecisionalSemanticCacheExps,
        data = Data([dataNoCacheExps,dataSemanticCacheExps, dataDecisionalSemanticCacheExps])

        layout = Layout(
            title = graphTitle,
            xaxis = XAxis(title = xTitle),
            yaxis = YAxis(title = yTitle)
        )

        fig = Figure(data=data, layout=layout)

        plot_url = plotly.plotly.plot(fig, filename = graphTitle)
        #plotly.plotly.image.save_as(fig, self.outputPath + '/processing_time_comparison.png')

    def showMoney(self,graphTitle,xTitle,yTitle):
        avgNoCacheExps = [0 for i in range(0,11)]
        avgSemanticCacheExps = [0 for i in range(0,11)]
        avgDecisionalSemanticCacheExps = [0 for i in range(0,11)]

        #build average measurements\

        if self.noCacheExps.keys():
            for i in range(0,11):
                for index in self.noCacheExps.keys():
                    avgNoCacheExps[i] += self.noCacheExps[index][i].getTotalMoneyCost()
                avgNoCacheExps[i] /= len(self.noCacheExps.keys())

        if self.semanticCacheExps.keys():
            for i in range(0,11):
                for index in self.semanticCacheExps.keys():
                    avgSemanticCacheExps[i] += self.semanticCacheExps[index][i].getTotalMoneyCost()
                avgSemanticCacheExps[i] /= len(self.semanticCacheExps.keys())

        if self.decisionalSemanticCacheExps.keys():
            for i in range(0,11):
                for index in self.decisionalSemanticCacheExps.keys():
                    avgDecisionalSemanticCacheExps[i] += self.decisionalSemanticCacheExps[index][i].getTotalMoneyCost()
                avgDecisionalSemanticCacheExps[i] /= len(self.decisionalSemanticCacheExps.keys())


        dataNoCacheExps = Scatter(
            x=[i*10 for i in range(0,11)],
            y=avgNoCacheExps,
            mode='lines+markers',
            name='No Cache'
        )

        dataSemanticCacheExps = Scatter(
            x=[i*10 for i in range(0,11)],
            y=avgSemanticCacheExps,
            mode='lines+markers',
            name='Semantic Caching'
        )

        dataDecisionalSemanticCacheExps = Scatter(
            x=[i*10 for i in range(0,11)],
            y=avgDecisionalSemanticCacheExps,
            mode='lines+markers',
            name='Decisional Semantic Caching'
        )


        #noCacheExps,dataSemanticCacheExps, dataDecisionalSemanticCacheExps,
        data = Data([dataNoCacheExps,dataSemanticCacheExps, dataDecisionalSemanticCacheExps])

        layout = Layout(
            title = graphTitle,
            xaxis = XAxis(title = xTitle),
            yaxis = YAxis(title = yTitle)
        )

        fig = Figure(data=data, layout=layout)

        plot_url = plotly.plotly.plot(fig, filename = graphTitle)
        #plotly.plotly.image.save_as(fig, self.outputPath + '/processing_time_comparison.png')

    def showCloudProcessingTimes(self,graphTitle,xTitle,yTitle):

        #avgNoCacheExps = [0 for i in range(0,11)]
        avgSemanticCacheExps = [0 for i in range(0,11)]
        avgDecisionalSemanticCacheExps = [0 for i in range(0,11)]

        #build average measurements\

        # if self.noCacheExps.keys():
        #     for i in range(0,11):
        #         for index in self.noCacheExps.keys():
        #             avgNoCacheExps[i] += self.noCacheExps[index][i].getCloudProcessingTime()
        #         avgNoCacheExps[i] /= len(self.noCacheExps.keys())
        #         avgNoCacheExps[i] /= 1000000000

        if self.semanticCacheExps.keys():
            for i in range(0,11):
                for index in self.semanticCacheExps.keys():
                    if float(self.semanticCacheExps[index][i].nbQueriesProcessedOnCloud) != 0:
                        avgSemanticCacheExps[i] += (self.semanticCacheExps[index][i].getNbQueriesNotRespectingConstraints()/float(self.semanticCacheExps[index][i].nbPosedQueries))*100
                    else:
                        avgSemanticCacheExps[i] = 0

                avgSemanticCacheExps[i] /= len(self.semanticCacheExps.keys())


                #avgSemanticCacheExps[i] /= 1000000000

        if self.decisionalSemanticCacheExps.keys():
            for i in range(0,11):
                for index in self.decisionalSemanticCacheExps.keys():
                    avgDecisionalSemanticCacheExps[i] += (self.decisionalSemanticCacheExps[index][i].getNbQueriesNotRespectingConstraints()/float(self.decisionalSemanticCacheExps[index][i].nbPosedQueries))*100
                avgDecisionalSemanticCacheExps[i] /= len(self.decisionalSemanticCacheExps.keys())

                #avgDecisionalSemanticCacheExps[i] /= 1000000000

        # dataNoCacheExps = Scatter(
        #     x=[i*10 for i in range(0,11)],
        #     y=avgNoCacheExps,
        #     mode='lines+markers',
        #     name='No Cache'
        # )

        dataSemanticCacheExps = Scatter(
            x=[i*10 for i in range(0,11)],
            y=avgSemanticCacheExps,
            mode='lines+markers',
            name='Semantic Caching'
        )

        dataDecisionalSemanticCacheExps = Scatter(
            x=[i*10 for i in range(0,11)],
            y=avgDecisionalSemanticCacheExps,
            mode='lines+markers',
            name='Decisional Semantic Caching'
        )


        #noCacheExps,dataSemanticCacheExps, dataDecisionalSemanticCacheExps,
        data = Data([ dataSemanticCacheExps, dataDecisionalSemanticCacheExps])

        layout = Layout(
            title = graphTitle,
            xaxis = XAxis(title = xTitle),
            yaxis = YAxis(title = yTitle)
        )

        fig = Figure(data=data, layout=layout)

        plot_url = plotly.plotly.plot(fig, filename = graphTitle)
        #plotly.plotly.image.save_as(fig, self.outputPath + '/processing_time_comparison.png')

    def showPercentQueriesProcessedCloud(self,graphTitle,xTitle,yTitle):

        avgDecisionalSemanticCacheFailedQueries = [0 for i in range(0,11)]
        avgSemanticCacheExpsCloud = [0 for i in range(0,11)]
        avgDecisionalSemanticCacheExpsCloud = [0 for i in range(0,11)]

        #build average measurements\



        if self.semanticCacheExps.keys():
            for i in range(0,11):
                for index in self.semanticCacheExps.keys():
                    avgSemanticCacheExpsCloud[i] += (self.semanticCacheExps[index][i].nbQueriesProcessedOnCloud/float(self.semanticCacheExps[index][i].nbPosedQueries))*100
                avgSemanticCacheExpsCloud[i] /= len(self.semanticCacheExps.keys())

        if self.decisionalSemanticCacheExps.keys():
            for i in range(0,11):
                for index in self.decisionalSemanticCacheExps.keys():
                    avgDecisionalSemanticCacheExpsCloud[i] += (self.decisionalSemanticCacheExps[index][i].nbQueriesProcessedOnCloud/float(self.decisionalSemanticCacheExps[index][i].nbPosedQueries))*100
                avgDecisionalSemanticCacheExpsCloud[i] /= len(self.decisionalSemanticCacheExps.keys())

        if self.decisionalSemanticCacheExps.keys():
            for i in range(0,11):
                for index in self.decisionalSemanticCacheExps.keys():
                    avgDecisionalSemanticCacheFailedQueries[i] += (self.decisionalSemanticCacheExps[index][i].nbFailedQueries/float(self.decisionalSemanticCacheExps[index][i].nbPosedQueries))*100
                avgDecisionalSemanticCacheFailedQueries[i] /= len(self.decisionalSemanticCacheExps.keys())



        dataSemanticCacheExpsCloud = Bar(
            x=[i*10 for i in range(0,11)],
            y=avgSemanticCacheExpsCloud,
            name='SC - % of Queries Processed On Cloud'
        )

        dataDecisionalSemanticCacheExpsCloud = Bar(
            x=[i*10 for i in range(0,11)],
            y=avgDecisionalSemanticCacheExpsCloud,
            name='MOCCAD-Cache - % of Queries Processed On Cloud'
        )

        dataDecisionalSemanticCacheFailedExps = Bar(
            x=[i*10 for i in range(0,11)],
            y=avgDecisionalSemanticCacheFailedQueries,
            name='MOCCAD-Cache - % of Queries Failed'
        )


        #noCacheExps,dataSemanticCacheExps, dataDecisionalSemanticCacheExps,
        data = Data([dataSemanticCacheExpsCloud, dataDecisionalSemanticCacheExpsCloud,dataDecisionalSemanticCacheFailedExps])

        layout = Layout(
            title = graphTitle,
            xaxis = XAxis(title = xTitle),
            yaxis = YAxis(title = yTitle),
            barmode = 'group'
        )

        fig = Figure(data=data, layout=layout)

        plot_url = plotly.plotly.plot(fig, filename = graphTitle)
        #plotly.plotly.image.save_as(fig, self.outputPath + '/processing_time_comparison.png')


    def showPercentQueriesProcessedMobile(self,graphTitle,xTitle,yTitle):

        avgSemanticCacheExpsMobile = [0 for i in range(0,11)]
        avgDecisionalSemanticCacheExpsMobile = [0 for i in range(0,11)]

        #build average measurements\


        if self.semanticCacheExps.keys():
            for i in range(0,11):
                for index in self.semanticCacheExps.keys():
                    avgSemanticCacheExpsMobile[i] += (self.semanticCacheExps[index][i].nbQueriesProcessedOnMobile/float(self.semanticCacheExps[index][i].nbPosedQueries))*100
                avgSemanticCacheExpsMobile[i] /= len(self.semanticCacheExps.keys())

        if self.decisionalSemanticCacheExps.keys():
            for i in range(0,11):
                for index in self.decisionalSemanticCacheExps.keys():
                    avgDecisionalSemanticCacheExpsMobile[i] += (self.decisionalSemanticCacheExps[index][i].nbQueriesProcessedOnMobile/float(self.decisionalSemanticCacheExps[index][i].nbPosedQueries))*100
                avgDecisionalSemanticCacheExpsMobile[i] /= len(self.decisionalSemanticCacheExps.keys())


        dataSemanticCacheExpsCloud = Bar(
            x=[i*10 for i in range(0,11)],
            y=avgSemanticCacheExpsMobile,
            name='SC - % of Queries Processed On Mobile'
        )

        dataDecisionalSemanticCacheExpsCloud = Bar(
            x=[i*10 for i in range(0,11)],
            y=avgDecisionalSemanticCacheExpsMobile,
            name='DSC - % of Queries Processed On Mobile'
        )


        #noCacheExps,dataSemanticCacheExps, dataDecisionalSemanticCacheExps,
        data = Data([dataSemanticCacheExpsCloud, dataDecisionalSemanticCacheExpsCloud])

        layout = Layout(
            title = graphTitle,
            xaxis = XAxis(title = xTitle),
            yaxis = YAxis(title = yTitle),
            barmode = 'group'
        )

        fig = Figure(data=data, layout=layout)

        plot_url = plotly.plotly.plot(fig, filename = graphTitle)
        #plotly.plotly.image.save_as(fig, self.outputPath + '/processing_time_comparison.png')


    def showMobileProcessingTimes(self,graphTitle,xTitle,yTitle):

        avgNoCacheExps = [0 for i in range(0,11)]
        avgSemanticCacheExps = [0 for i in range(0,11)]
        avgDecisionalSemanticCacheExps = [0 for i in range(0,11)]

        #build average measurements\

        if self.noCacheExps.keys():
            for i in range(0,11):
                for index in self.noCacheExps.keys():
                    avgNoCacheExps[i] += self.noCacheExps[index][i].getMobileProcessingTime()
                avgNoCacheExps[i] /= len(self.noCacheExps.keys())

        if self.semanticCacheExps.keys():
            for i in range(0,11):
                for index in self.semanticCacheExps.keys():
                    avgSemanticCacheExps[i] += self.semanticCacheExps[index][i].getMobileProcessingTime()
                avgSemanticCacheExps[i] /= len(self.semanticCacheExps.keys())
                avgSemanticCacheExps[i] /= 1000000000

        if self.decisionalSemanticCacheExps.keys():
            for i in range(0,11):
                for index in self.decisionalSemanticCacheExps.keys():
                    avgDecisionalSemanticCacheExps[i] += self.decisionalSemanticCacheExps[index][i].getMobileProcessingTime()
                avgDecisionalSemanticCacheExps[i] /= len(self.decisionalSemanticCacheExps.keys())
                avgDecisionalSemanticCacheExps[i] /= 1000000000

        noCacheExps = Scatter(
            x=[i*10 for i in range(0,11)],
            y=avgNoCacheExps
        )

        dataSemanticCacheExps = Scatter(
            x=[i*10 for i in range(0,11)],
            y=avgSemanticCacheExps,
            mode='lines+markers',
            name='Semantic Caching'
        )

        dataDecisionalSemanticCacheExps = Scatter(
            x=[i*10 for i in range(0,11)],
            y=avgDecisionalSemanticCacheExps,
            mode='lines+markers',
            name='Decisional Semantic Caching'
        )


        #noCacheExps,dataSemanticCacheExps, dataDecisionalSemanticCacheExps,
        data = Data([dataSemanticCacheExps, dataDecisionalSemanticCacheExps])

        layout = Layout(
            title = graphTitle,
            xaxis = XAxis(title = xTitle),
            yaxis = YAxis(title = yTitle)
        )

        fig = Figure(data=data, layout=layout)

        plot_url = plotly.plotly.plot(fig, filename = graphTitle)
        #plotly.plotly.image.save_as(fig, self.outputPath + '/processing_time_comparison.png')

    def showSizeQueriesReprocessedOnCloud(self,graphTitle,xTitle,yTitle):

        avgDecisionalSemanticCacheExps = [0 for i in range(0,11)]

        if self.decisionalSemanticCacheExps.keys():
            for i in range(0,11):
                for index in self.decisionalSemanticCacheExps.keys():
                    avgDecisionalSemanticCacheExps[i] += self.decisionalSemanticCacheExps[index][i].getTotalSizeOfQueriesReprocessedOnCloud()
                avgDecisionalSemanticCacheExps[i] /= len(self.decisionalSemanticCacheExps.keys())

        dataDecisionalSemanticCacheExps = Scatter(
            x=[i*10 for i in range(0,11)],
            y=avgDecisionalSemanticCacheExps,
            mode='lines+markers',
            name='Decisional Semantic Caching'
        )


        data = Data([dataDecisionalSemanticCacheExps])

        layout = Layout(
            title = graphTitle,
            xaxis = XAxis(title = xTitle),
            yaxis = YAxis(title = yTitle)
        )

        fig = Figure(data=data, layout=layout)

        plot_url = plotly.plotly.plot(fig, filename = graphTitle)
        #plotly.plotly.image.save_as(fig, self.outputPath + '/processing_time_comparison.png')