__author__ = 'Mikael'

from HitType import HitType
from os.path import join

class QuerySetFilesGenerator:

    cacheExactHitFileName = 'cache_exact_hit_queries.txt'
    cacheExtendedHitFileName = 'cache_extended_hit_queries.txt'
    cachePartialHitFileName = 'cache_partial_hit_queries.txt'
    cacheMissFileName = 'cache_miss_queries.txt'

    def __init__(self,outputPath, exp):
        self.outputPath = outputPath
        self.experimentation = exp


    def generateQuerySetFiles(self):

        cacheExactHitFile = open(join(self.outputPath,QuerySetFilesGenerator.cacheExactHitFileName), 'w')
        cacheExtendedHitFile = open(join(self.outputPath, QuerySetFilesGenerator.cacheExtendedHitFileName), 'w')
        cachePartialHitFile = open(join(self.outputPath, QuerySetFilesGenerator.cachePartialHitFileName), 'w')
        cacheMissFile = open(join(self.outputPath, QuerySetFilesGenerator.cacheMissFileName), 'w')

        for m in self.experimentation.queryMeasurements:
            if m.hitType == HitType.cache_hit:
                cacheExactHitFile.write(m.query.strip()+'\n')
            elif m.hitType == HitType.cache_partial_hit:
                cachePartialHitFile.write(m.query.strip()+'\n')
            elif m.hitType == HitType.cache_extended_hit:
                cacheExtendedHitFile.write(m.query.strip()+'\n')
            elif m.hitType == HitType.cache_miss:
                cacheMissFile.write(m.query.strip()+'\n')

        cacheExactHitFile.close()
        cacheExtendedHitFile.close()
        cachePartialHitFile.close()
        cacheMissFile.close()
