﻿using OUDBCommonLibs.Interfaces;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OUDBCache.Cache.SemanticCache
{
    public class SemanticCacheRegion<RT, PT> : ISemanticCacheRegion<RT, PT>
        where PT : new()
    {
        public SemanticCacheRegion(IQuery<RT,PT> query, IList<PT> tuples)
        {
            this.Query = query;
            this.CachedTuples = tuples;
            this.ProjectedType = typeof(PT);

            this.LastUsed = DateTime.Now;
        }

        public IQuery<RT, PT> Query
        {
            get;
            private set;
        }

        public IList<PT> CachedTuples
        {
            get;
            private set;
        }

        public Type ProjectedType
        {
            get;
            private set;
        }

        public DateTime LastUsed
        {
            get;
            set;
        }

        public IQuery<RT> UnTypedQuery
        {
            get { return this.Query; }
        }

        public IList<object> UnTypedCachedTuples
        {
            get { return this.CachedTuples.Select(x => (object)x).ToList(); }
        }
    }
}
