﻿using OUDBCommonLibs.Interfaces;
using OUDBCommonLibs.Variables;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OUDBCommonLibs.Generators
{
    public class RandomSelectorGenerator<T> : GeneratorBase<T>
    {
        public RandomSelectorGenerator(IList<T> possible, RandomNumericVariableBase randomSelector)
        {
            this.Possible = possible;
            this.PossibleIndexSelector = randomSelector;
        }

        public IList<T> Possible { get; private set; }

        public RandomNumericVariableBase PossibleIndexSelector { get; private set; }

        public override T GenerateValue()
        {
            return this.Possible[(int)this.PossibleIndexSelector.Sample()];
        }
    }
}
