﻿using OUDBCommonLibs.Interfaces;
using OUDBCommonLibs.Variables;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OUDBCommonLibs.Generators
{
    public class RandomStringGenerator : RandomSetGenerator<char, string>
    {
        public RandomStringGenerator(IList<char> alphabet, RandomNumericVariableBase randomAlphabetSelector, RandomNumericVariableBase randomLengthSelector)
            :base(alphabet, randomAlphabetSelector, randomLengthSelector, selectedValues => string.Join("", selectedValues) )
        {

        }
    }

    public class RandomLowerCaseAlphaStringGenerator : RandomStringGenerator
    {
        public RandomLowerCaseAlphaStringGenerator(RandomNumericVariableBase randomAlphabetSelector, RandomNumericVariableBase randomLengthSelector)
            :base(new List<char>(new char[]{'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o','p', 'q', 'r', 's', 't', 'u', 'v','w','x','y','z'}),
                    randomAlphabetSelector,
                    randomLengthSelector)
        { }

        public RandomLowerCaseAlphaStringGenerator(RandomNumericVariableBase randomLengthSelector)
            : this(new UniformVariable(0, 26),
                    randomLengthSelector)
        { }

        public RandomLowerCaseAlphaStringGenerator()
            : this(new UniformVariable(5, 255))
        { }
    }
}
