﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;
using System.Text;
using System.Threading.Tasks;

namespace OUDBCommonLibs.Interfaces
{
    public interface IQuery
    {
        IPredicate UnTypedPredicate { get; }
    }
    public interface IQuery<RT> : IQuery
    {
        IPredicate<RT> Predicate { get; }
    }
    public interface IQuery<RT, PT> : IQuery<RT>
        where PT : new()
    {
        IProjection<RT, PT> Projection { get; }
    }

    public interface IQueryResult<RT, PT>
        where PT : new()
    {
        IQuery<RT, PT> Query { get; }

        IList<PT> Tuples { get; }
    }
}
