﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OUDBCommonLibs.Interfaces
{
    public interface IVariable<T>
    {
        T Sample();
    }

    public interface IRandomVariable<T> : IVariable<T> 
    {
        Random Random { get; }
    }

    public interface IRandomVariableWithMean<T> : IRandomVariable<T>
    {
        double Mean { get; }
    }

    public interface IQuantile<T>
    {
        T CalculateValue(double probability);
        double CalculateProbability(T value);
    }
}
