﻿using OUDBCommonLibs.Interfaces;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OUDBCommonLibs.Query
{
    public class QueryResult<RT,PT> : IQueryResult<RT,PT>
        where PT : new()
    {
        public QueryResult(IQuery<RT, PT> query)
        {
            this.Query = query;
            this.Tuples = new List<PT>();
        }

        public QueryResult(IQuery<RT, PT> query, params PT[] tuples)
            :this(query)
        {
            foreach(PT t in tuples){
                this.Tuples.Add(t);
            }
        }

        public IList<PT> Tuples
        {
            get;
            private set;
        }

        public IQuery<RT, PT> Query
        {
            get;
            private set;
        }
    }
}
