﻿using OUDBCommonLibs.Interfaces;
using OUDBCommonLibs.Predicates;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using OUDBCommonLibs.ExtensionMethods;
using OUDBCommonLibs.Attributes;
using OUDBCommonLibs.Variables;
using System.Collections;
using OUDBCommonLibs.IntervalTree;

namespace OUDBCommonLibs.Util
{
    public class AttributePredicateInterval<RT,AT>
        where AT :struct, IComparable<AT>
    {
        public AttributePredicateInterval(string attrName, IPredicate<RT> predicate)
        {
            this.AttributeName = attrName;
            this.AttributePredicate = predicate;
        }

        public string AttributeName { get; private set; }
        public IPredicate<RT> AttributePredicate { get; private set; }

        public bool IsPredicateValid()
        {
            IList<ITupleAttributeDesc> attrDesc = this.AttributePredicate.GetPredicateAttributes<RT>();

            if (attrDesc == null) return false;

            if (attrDesc.ToList().Exists(x => x.Name != this.AttributeName || x.RelationType != typeof(RT))) return false;

            return true;
        }

        public bool IsInInterval(AT value)
        {
            return this.AttributePredicate.IsInInterval(value);
        } 
    }

}
