﻿using OUDBCommonLibs.Interfaces;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OUDBCommonLibs.Variables
{
    public class ConstantVariable : RandomNumericVariableWithMeanBase
    {
        public ConstantVariable():
            this(0) { }

        public ConstantVariable(double constant)
            : base()
        {
            this.Constant = constant;
        }

        public override double Sample()
        {
            return this.Constant;
        }

        public double Constant { get; private set; }

        public override double Mean
        {
            get { return this.Constant; }
            protected set { throw new NotImplementedException(); }
        }
    }
}
