﻿using OUDBCommonLibs.Attributes;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Globalization;
using System.Threading.Tasks;

namespace OUDBQueryGenerationConsole
{
    public static class ExtensionMethods
    {

        public static string TupleToOutputString<T>(this T tuple)
        {
            return TupleToOutputString(tuple, ", ");
        }

        public static string TupleToOutputString<T>(this T tuple, string separator)
        {
            StringBuilder sb = new StringBuilder();
            CultureInfo enUS = CultureInfo.CreateSpecificCulture("en-US");

            Type type = typeof(T);
            foreach (PropertyInfo pInfo in type.GetProperties())
            {
                Attribute attr = pInfo.GetCustomAttribute(typeof(TuplePropertyAttribute));

                if (attr != null)
                {
                    object value = pInfo.GetGetMethod().Invoke(tuple, null);

                    sb.AppendFormat(enUS, string.Format("{0}",value));
                    sb.Append(separator);
                }
            }

            return sb.ToString();
        }
    }
}
