﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Threading.Tasks;
using OUDBCommonLibs.Interfaces;
using System.Globalization;
using OUDBCommonLibs.ExtensionMethods;

namespace OUDBQueryGenerationConsole
{
    public class RelationWrapper<RT>
    {
        public const string SVG_FILE_DIR = @"C:\Users\Public\GeneratedRelation\";

        public IRelation<RT> Relation { get; private set; }

        public RelationWrapper(IRelation<RT> r)
        {
            Relation = r;
        }

        public void Display()
        {
            Console.WriteLine(Relation);
        }

        /**
         * Writes 
         */
        public void SaveToFile(String fileName = @"svgRelation.tbl")
        {
            if (!Directory.Exists(SVG_FILE_DIR))
            {
                Directory.CreateDirectory(SVG_FILE_DIR);
            }

            string filePath = SVG_FILE_DIR + fileName; 

            

            // builds the string tuples
            StringBuilder sb = new StringBuilder();
            foreach (RT tuple in Relation.Tuples)
            {
                sb.AppendLine(tuple.TupleToOutputString("|"));
            }

            // writes in the file
            try
            {
                File.WriteAllText(filePath, sb.ToString());
                Console.WriteLine(filePath + " created");
            }
            catch(IOException e)
            {
                Console.WriteLine("{0}: The write operation could not " +
                    "be performed because the specified " +
                    "part of the file is locked.",
                    e.GetType().Name);
            }
            
        }


    }
}
